<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirOriginDestination ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirOriginDestination
 * @subpackage Arrays
 */
class ArrayOfAirOriginDestination extends AbstractStructArrayBase
{
    /**
     * The AirOriginDestination
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AirOriginDestination[]
     */
    public $AirOriginDestination;
    /**
     * Constructor method for ArrayOfAirOriginDestination
     * @uses ArrayOfAirOriginDestination::setAirOriginDestination()
     * @param \App|C\StructType\AirOriginDestination[] $airOriginDestination
     */
    public function __construct(array $airOriginDestination = array())
    {
        $this
            ->setAirOriginDestination($airOriginDestination);
    }
    /**
     * Get AirOriginDestination value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AirOriginDestination[]|null
     */
    public function getAirOriginDestination()
    {
        return isset($this->AirOriginDestination) ? $this->AirOriginDestination : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirOriginDestination method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirOriginDestination method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirOriginDestinationForArrayConstraintsFromSetAirOriginDestination(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirOriginDestinationAirOriginDestinationItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirOriginDestinationAirOriginDestinationItem instanceof \App|C\StructType\AirOriginDestination) {
                $invalidValues[] = is_object($arrayOfAirOriginDestinationAirOriginDestinationItem) ? get_class($arrayOfAirOriginDestinationAirOriginDestinationItem) : sprintf('%s(%s)', gettype($arrayOfAirOriginDestinationAirOriginDestinationItem), var_export($arrayOfAirOriginDestinationAirOriginDestinationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirOriginDestination property can only contain items of type \App|C\StructType\AirOriginDestination, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirOriginDestination value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\AirOriginDestination[] $airOriginDestination
     * @return \App|C\ArrayType\ArrayOfAirOriginDestination
     */
    public function setAirOriginDestination(array $airOriginDestination = array())
    {
        // validation for constraint: array
        if ('' !== ($airOriginDestinationArrayErrorMessage = self::validateAirOriginDestinationForArrayConstraintsFromSetAirOriginDestination($airOriginDestination))) {
            throw new \InvalidArgumentException($airOriginDestinationArrayErrorMessage, __LINE__);
        }
        if (is_null($airOriginDestination) || (is_array($airOriginDestination) && empty($airOriginDestination))) {
            unset($this->AirOriginDestination);
        } else {
            $this->AirOriginDestination = $airOriginDestination;
        }
        return $this;
    }
    /**
     * Add item to AirOriginDestination value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\AirOriginDestination $item
     * @return \App|C\ArrayType\ArrayOfAirOriginDestination
     */
    public function addToAirOriginDestination(\App|C\StructType\AirOriginDestination $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\AirOriginDestination) {
            throw new \InvalidArgumentException(sprintf('The AirOriginDestination property can only contain items of type \App|C\StructType\AirOriginDestination, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirOriginDestination[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\AirOriginDestination|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\AirOriginDestination|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\AirOriginDestination|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\AirOriginDestination|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\AirOriginDestination|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirOriginDestination
     */
    public function getAttributeName()
    {
        return 'AirOriginDestination';
    }
}
