<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareInfoBooking StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FareInfoBooking
 * @subpackage Structs
 */
class FareInfoBooking extends FareInfoEMD
{
    /**
     * The SaleCurrencyAmountToPay
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AmountBase
     */
    public $SaleCurrencyAmountToPay;
    /**
     * The SaleCurrencyAmountToPayInAccount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $SaleCurrencyAmountToPayInAccount;
    /**
     * The SaleCurrencyTravelerAmountToPay
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AmountTraveler
     */
    public $SaleCurrencyTravelerAmountToPay;
    /**
     * The SaleCurrencyTravelerAmountToPayInAccount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AmountTraveler
     */
    public $SaleCurrencyTravelerAmountToPayInAccount;
    /**
     * Constructor method for FareInfoBooking
     * @uses FareInfoBooking::setSaleCurrencyAmountToPay()
     * @uses FareInfoBooking::setSaleCurrencyAmountToPayInAccount()
     * @uses FareInfoBooking::setSaleCurrencyTravelerAmountToPay()
     * @uses FareInfoBooking::setSaleCurrencyTravelerAmountToPayInAccount()
     * @param \App|C\StructType\AmountBase $saleCurrencyAmountToPay
     * @param float $saleCurrencyAmountToPayInAccount
     * @param \App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPay
     * @param \App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPayInAccount
     */
    public function __construct(\App|C\StructType\AmountBase $saleCurrencyAmountToPay = null, $saleCurrencyAmountToPayInAccount = null, \App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPay = null, \App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPayInAccount = null)
    {
        $this
            ->setSaleCurrencyAmountToPay($saleCurrencyAmountToPay)
            ->setSaleCurrencyAmountToPayInAccount($saleCurrencyAmountToPayInAccount)
            ->setSaleCurrencyTravelerAmountToPay($saleCurrencyTravelerAmountToPay)
            ->setSaleCurrencyTravelerAmountToPayInAccount($saleCurrencyTravelerAmountToPayInAccount);
    }
    /**
     * Get SaleCurrencyAmountToPay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AmountBase|null
     */
    public function getSaleCurrencyAmountToPay()
    {
        return isset($this->SaleCurrencyAmountToPay) ? $this->SaleCurrencyAmountToPay : null;
    }
    /**
     * Set SaleCurrencyAmountToPay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AmountBase $saleCurrencyAmountToPay
     * @return \App|C\StructType\FareInfoBooking
     */
    public function setSaleCurrencyAmountToPay(\App|C\StructType\AmountBase $saleCurrencyAmountToPay = null)
    {
        if (is_null($saleCurrencyAmountToPay) || (is_array($saleCurrencyAmountToPay) && empty($saleCurrencyAmountToPay))) {
            unset($this->SaleCurrencyAmountToPay);
        } else {
            $this->SaleCurrencyAmountToPay = $saleCurrencyAmountToPay;
        }
        return $this;
    }
    /**
     * Get SaleCurrencyAmountToPayInAccount value
     * @return float|null
     */
    public function getSaleCurrencyAmountToPayInAccount()
    {
        return $this->SaleCurrencyAmountToPayInAccount;
    }
    /**
     * Set SaleCurrencyAmountToPayInAccount value
     * @param float $saleCurrencyAmountToPayInAccount
     * @return \App|C\StructType\FareInfoBooking
     */
    public function setSaleCurrencyAmountToPayInAccount($saleCurrencyAmountToPayInAccount = null)
    {
        // validation for constraint: float
        if (!is_null($saleCurrencyAmountToPayInAccount) && !(is_float($saleCurrencyAmountToPayInAccount) || is_numeric($saleCurrencyAmountToPayInAccount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($saleCurrencyAmountToPayInAccount, true), gettype($saleCurrencyAmountToPayInAccount)), __LINE__);
        }
        $this->SaleCurrencyAmountToPayInAccount = $saleCurrencyAmountToPayInAccount;
        return $this;
    }
    /**
     * Get SaleCurrencyTravelerAmountToPay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AmountTraveler|null
     */
    public function getSaleCurrencyTravelerAmountToPay()
    {
        return isset($this->SaleCurrencyTravelerAmountToPay) ? $this->SaleCurrencyTravelerAmountToPay : null;
    }
    /**
     * Set SaleCurrencyTravelerAmountToPay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPay
     * @return \App|C\StructType\FareInfoBooking
     */
    public function setSaleCurrencyTravelerAmountToPay(\App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPay = null)
    {
        if (is_null($saleCurrencyTravelerAmountToPay) || (is_array($saleCurrencyTravelerAmountToPay) && empty($saleCurrencyTravelerAmountToPay))) {
            unset($this->SaleCurrencyTravelerAmountToPay);
        } else {
            $this->SaleCurrencyTravelerAmountToPay = $saleCurrencyTravelerAmountToPay;
        }
        return $this;
    }
    /**
     * Get SaleCurrencyTravelerAmountToPayInAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AmountTraveler|null
     */
    public function getSaleCurrencyTravelerAmountToPayInAccount()
    {
        return isset($this->SaleCurrencyTravelerAmountToPayInAccount) ? $this->SaleCurrencyTravelerAmountToPayInAccount : null;
    }
    /**
     * Set SaleCurrencyTravelerAmountToPayInAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPayInAccount
     * @return \App|C\StructType\FareInfoBooking
     */
    public function setSaleCurrencyTravelerAmountToPayInAccount(\App|C\StructType\AmountTraveler $saleCurrencyTravelerAmountToPayInAccount = null)
    {
        if (is_null($saleCurrencyTravelerAmountToPayInAccount) || (is_array($saleCurrencyTravelerAmountToPayInAccount) && empty($saleCurrencyTravelerAmountToPayInAccount))) {
            unset($this->SaleCurrencyTravelerAmountToPayInAccount);
        } else {
            $this->SaleCurrencyTravelerAmountToPayInAccount = $saleCurrencyTravelerAmountToPayInAccount;
        }
        return $this;
    }
}
