<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OfferIn StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OfferIn
 * @subpackage Structs
 */
class OfferIn extends OfferRef
{
    /**
     * The RefItinerary
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefItinerary;
    /**
     * Constructor method for OfferIn
     * @uses OfferIn::setRefItinerary()
     * @param string $refItinerary
     */
    public function __construct($refItinerary = null)
    {
        $this
            ->setRefItinerary($refItinerary);
    }
    /**
     * Get RefItinerary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefItinerary()
    {
        return isset($this->RefItinerary) ? $this->RefItinerary : null;
    }
    /**
     * Set RefItinerary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refItinerary
     * @return \App|C\StructType\OfferIn
     */
    public function setRefItinerary($refItinerary = null)
    {
        // validation for constraint: string
        if (!is_null($refItinerary) && !is_string($refItinerary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refItinerary, true), gettype($refItinerary)), __LINE__);
        }
        if (is_null($refItinerary) || (is_array($refItinerary) && empty($refItinerary))) {
            unset($this->RefItinerary);
        } else {
            $this->RefItinerary = $refItinerary;
        }
        return $this;
    }
}
